#include <iostream>
#include <iomanip>
#include <stdlib.h>
#include <sys/time.h>

using namespace std;

/* Matrixgroesse */
#ifndef N
#define N 1024
#endif

/* Padding */
#ifndef PAD
#define PAD 0
#endif

/* Anzahl der Bloecke fr das Tiling */
#ifndef B
#define B 0
#endif



double a[N][N+PAD], b[N][N+PAD], c[N][N+PAD];

double getTime()
{
	struct timeval tv;
	gettimeofday(&tv, NULL);
	return tv.tv_sec + tv.tv_usec * 0.000001;
}

int main()
{
	double t0;
	int i, j, k, ii, jj, kk;

	for (i=0; i<N; i++) {
		for (j=0; j<N; j++) {
			a[i][j] = i/(j+1.0)/N;
			b[i][j] = (i+1.0)/(j+10)/N;
			c[i][j] = 0;
		}
	}

#if (B == 0)
	t0 = getTime();
	for (i=0; i<N; i++) {
		for (k=0; k<N; k++) {
			for (j=0; j<N; j++) {
				c[i][j] += a[i][k] * b[k][j];
			}
		}
	}
	cout << setw(4) << N << " x " << (N+PAD) << ": "
		 <<	fixed << setprecision(3)
		 << (1e-9*2.0*N*N*N/(getTime()-t0)) << " GFlop/s\n";

#else
	t0 = getTime();
	for (ii=0; ii<B; ii++) {
		for (kk=0; kk<B; kk++) {
			for (jj=0; jj<B; jj++) {
				for (i=0; i<N/B; i++) {
					for (k=0; k<N/B; k++) {
						for (j=0; j<N/B; j++) {
							c[i+ii*N/B][j+jj*N/B] += a[i+ii*N/B][k+kk*N/B] * b[k+kk*N/B][j+jj*N/B];
						}
					}
				}
			}
		}
	}
	cout << setw(4) << N << " x " << (N+PAD) << " blocked " << B << ": "
		 <<	fixed << setprecision(3)
		 << (1e-9*2.0*N*N*N/(getTime()-t0)) << " GFlop/s\n";
#endif

	return 0;
}


